#include "led.h"

void *led_main_task();

int main(int argc, char *argv[])
{
	int i, task_mode = 0, task_repeat;
	pthread_t red, blue, orange;
	void *main_result = NULL, *blue_result = NULL, *orange_result = NULL;
	
	if(argc != 1 && argc != 3)
	{
		printf("Usage : %s GPIO_NO\n", argv[0]);
		exit(1);
	}
	if (argc == 3)
	{
		task_mode = atoi(argv[1]);
		task_repeat = atoi(argv[2]);
	}
	for (i = 0; argv[i]; i++)
	{
		printf("%s ", argv[i]);
	}
	printf("\n");
	
	wiringPiSetup();
	
	if (task_mode == 0)
	{
		pthread_create(&red, NULL, led_main_task, NULL);
		pthread_join(red, &main_result);
		printf("led red blinked %d times\n", (int)main_result);
	}
	else if (task_mode == 1)
	{
		pthread_create(&red, NULL, led_main_task, NULL);
		pthread_create(&blue, NULL, led_blue_task, (void *)task_repeat);
		pthread_join(red, &main_result);
		printf("led red blinked %d times\n", (int)main_result);
		pthread_join(blue, &blue_result);
		printf("led blue blinked %d times\n", (int)blue_result);
	}
	else if (task_mode == 2)
	{
		pthread_create(&red, NULL, led_main_task, NULL);
		pthread_create(&orange, NULL, led_orange_task, (void *)task_repeat);
		pthread_join(red, &main_result);
		printf("led red blinked %d times\n", (int)main_result);
		pthread_join(orange, &orange_result);
		printf("led orange blinked %d times\n", (int)orange_result);
	}
	else if (task_mode == 3)
	{
		pthread_create(&red, NULL, led_main_task, NULL);
		pthread_create(&blue, NULL, led_blue_task, (void *)task_repeat);
		pthread_create(&orange, NULL, led_orange_task, (void *)task_repeat);
		pthread_join(red, &main_result);
		printf("led red blinked %d times\n", (int)main_result);
		pthread_join(blue, &blue_result);
		printf("led blue blinked %d times\n", (int)blue_result);
		pthread_join(orange, &orange_result);
		printf("led orange blinked %d times\n", (int)orange_result);
	}

	return 0;
}

void *led_main_task()
{
	printf("led main task start\n");
	int i, count = 0;
	pinMode(1, OUTPUT);
	
	for (i = 0; i < 10; i++, count++)
	{
		digitalWrite(1, HIGH);
		printf("red ON\n");
		delay(1000);
		digitalWrite(1, LOW);
		printf("red OFF\n");
		delay(1000);
	}
	
	printf("led main task end\n");
	pthread_exit((void *)count);
}
